<?php

namespace Drupal\svg_sprite;

use Drupal\Component\Utility\Xss;

/**
 * Various helper functions for the svg_sprite module.
 */
class SvgSpriteHelper {

  /**
   * SVG sprite compatible allowed HTML tags for admin.
   *
   * @var array
   */
  protected static array $xssAdminTags;

  /**
   * Add 'svg' and 'use' to the allowed admin tags.
   *
   * This allows usage of the svg_sprite token in some restricted contexts.
   */
  public static function addSvgSpriteTagsToAdminTags(): void {
    if (!isset(self::$xssAdminTags)) {
      $reflection = new \ReflectionClass(Xss::class);
      $property = $reflection->getProperty('adminTags');
      $property->setAccessible(TRUE);
      $admin_tags = $property->getValue(NULL);
      $admin_tags = array_merge($admin_tags, ['svg', 'use']);
      $admin_tags = array_unique($admin_tags);
      $property->setValue(NULL, $admin_tags);
      self::$xssAdminTags = $admin_tags;
    }
  }

}
